<?php
/*
Plugin Name: Smarter Excerpt
Plugin URI: http://theme.charlesstricklin.com/2005/04/30/smarter-excerpt/
Description: Displays the excerpt using whole words, and includes links and styling.
Version: 1.3
Author: Charles W. Stricklin
Author URI: http://charlesstricklin.com
*/

/*
4/29/2005	Initial release.
5/2/2005	Removed double filtering that invalidated markup.
6/12/2005	Condensed to one function, changed filtering.
6/13/2005	Removed wp_trim_excerpt filter and changed smarter_excerpt filter to get_the_excerpt. (Thanks, Mark)
*/

function smarter_excerpt( $excerpt ) {
	global $id, $post;
	$output = '';
	$excerpt_length = 120;
	$ellipsis = '...';

	if (!empty($post->post_password)) { // if there's a password
		if ($_COOKIE['wp-postpass_'.COOKIEHASH] != $post->post_password) {  // and it doesn't match the cookie
			$excerpt = '';
		}
		// end if ($_COOKIE['wp-postpass_'.COOKIEHASH] != $post->post_password)
	}
	// end if (!empty($post->post_password))
	else {
		$excerpt = $post->post_content;
		$words = explode(' ', $excerpt);
		if (count($words) > $excerpt_length) {
			$excerpt = implode(' ', array_slice($words, 0, $excerpt_length)) . $ellipsis;
		}
		// if (count($excerpt) > $excerpt_length)
	}
	// end else if (!empty($post->post_password))

	return $excerpt;
} // end smarter_excerpt()

remove_filter('get_the_excerpt', 'wp_trim_excerpt');
add_filter('get_the_excerpt', 'smarter_excerpt');
?>